# Filename:     tb_add3.do
# Filetype:     Modelsim Script File
# Date:         11 jan 2022
# Update:       -
# Description:  Script File For Automatic Simulation
# Author:       J. op den Brouw
# State:        Lab
# Error:        -
# Version:      1.2
# Copyright:    (c)2022, De Haagse Hogeschool

# Transcript on, we see output
transcript on

# Recreate working directory
if {[file exists rtl_work]} {
	vdel -lib rtl_work -all
}
vlib rtl_work
vmap work rtl_work

foreach vhd_file [ glob *.vhd ] {
	puts "Compiling: $vhd_file"
	vcom -2008 -work work $vhd_file
}

# Start the simulator
vsim -t 1ns -L rtl_work -L work -voptargs="+acc" add3

# Log all signals in the design, good if the number
# of signals is small.
add log -r *

# Add all toplevel signals
# Add a number of signals of the simulated design
add list -nodelta -label SW3 sw3 
add list -nodelta -label SW2 sw2 
add list -nodelta -label SW1 sw1 
add list -nodelta -label SW0 sw0 
add list -nodelta -width 5 -label LEDR3 ledr3 
add list -nodelta -label LEDR2 ledr2
add list -nodelta -label LEDR1 ledr1
add list -nodelta -label LEDR0 ledr0

# Open List window
noview Wave
noview Signals
noview Structure
view list

# Apply stimuli
force SW0 0 0, 1 20 -repeat 40 -cancel 320
force SW1 0 0, 1 40 -repeat 80 -cancel 320
force SW2 0 0, 1 80 -repeat 160 -cancel 320
force SW3 0 0, 1 160  -repeat 320 -cancel 320

# Run simulation for 300 ns
run 300 ns
